#guard enity

#define enity_included = true;
setdef uses_Enities = ,Enities 


define {

    OBJECT_HIRED        = GetSoldUnit()
    OBJECT_INITIATOR    = GetTriggerUnit()
    OBJECT_TRADER       = GetSellingUnit()
    OBJECT_CASTER       = GetSpellAbilityUnit()
    OBJECT_CAST_TARGET  = GetSpellTargetUnit()
    OBJECT_DAMAGER      = GetEventDamageSource()
    OBJECT_LEARNER      = GetLearningUnit()
    OBJECT_MANIPULATOR  = GetManipulatingUnit()
    OBJECT_KILLER       = GetKillingUnit()
    OBJECT_DYING        = GetDyingUnit()

    OBJECT_CAST_ID      = GetSpellAbilityId()
    OBJECT_SKILL_ID     = GetLearnedSkill()
    OBJECT_SKILL_LVL    = GetLearnedSkillLevel()

    // События объектов аля юнитов

     EVENT_OBJ_ATTACKED          = EVENT_UNIT_ATTACKED
     EVENT_OBJ_CAST              = EVENT_UNIT_SPELL_EFFECT
     EVENT_OBJ_PICKUP_STUFF      = EVENT_UNIT_PICKUP_ITEM
     EVENT_OBJ_DROP_STUFF        = EVENT_UNIT_DROP_ITEM
     EVENT_OBJ_DAMAGED           = EVENT_UNIT_DAMAGED
     EVENT_OBJ_DEATH             = EVENT_UNIT_DEATH
     EVENT_OBJ_SKILL             = EVENT_UNIT_HERO_SKILL

     STUFF_MANIPULATED           = GetManipulatedItem()
};


namespace Enities using General uses_TimeOut


private int FLY_MODE_ABILITY = 0x416D7266;

hashtable enity_hash = InitHashtable()

class heroproperties {
    int     xint            = 0;
    int     xagi            = 0;
    int     xstr            = 0;

    float   mpa_regen       = 0.0;
    float   hpa_regen       = 0.0;

    destructor(){

        this.xint       = 0;
        this.xstr       = 0;
        this.xagi       = 0;

        this.mpa_regen  = 0.0;
        this.hpa_regen  = 0.0;


        free self;
    };

    constructor(){
        return itself.allocate();
    };

}

#define <new heroproperties> = heroproperties.create()

class objectproperties{
    float   dodge_chance    = 0.0;
    float   block_chance    = 0.0;
    float   block_value     = 0.0;
    float   spell_crit      = 0.0;
    float   spell_chance    = 0.0;
    float   power_crit      = 0.0;
    float   power_chance    = 0.0;

    #if attribute_included

    int     xarmor          = 0;
    int     xattack         = 0;
    int     xratio          = 0;

    #endif

    float   resistance      = 0.0;
    float   manaresist      = 0.0;

    float   hp_regen        = 0.0;
    float   mp_regen        = 0.0;

    destructor(){

        this.dodge_chance   = 0.0;
        this.block_chance   = 0.0;
        this.block_value    = 0.0;
        this.spell_crit     = 0.0;
        this.spell_chance   = 0.0;
        this.power_crit     = 0.0;
        this.power_chance   = 0.0;

        this.resistance     = 0.0;
        this.manaresist     = 0.0;

        this.hp_regen       = 0.0;
        this.mp_regen       = 0.0;

        free self;
    };

    constructor(){
        return itself.allocate();
    };    
}

#define <new objectproperties> = objectproperties.create()

#if basedata_included 
void ht_regen(){
    exec ex = GetLastExec();
    float hps = (ex.o.basedata.hp_regen + ex.o.prop.hp_regen + ex.o.heroprop.hpa_regen) * 0.05;
    float mps = (ex.o.basedata.mp_regen + ex.o.prop.mp_regen + ex.o.heroprop.mpa_regen) * 0.05;
    ex.o.life = ex.o.life + hps;
    ex.o.mana = ex.o.mana + mps;
}

void ut_regen(){
    exec ex = GetLastExec();
    float hps = (ex.o.basedata.hp_regen + ex.o.prop.hp_regen ) * 0.05;
    float mps = (ex.o.basedata.mp_regen + ex.o.prop.mp_regen ) * 0.05;
    ex.o.life = ex.o.life + hps;
    ex.o.mana = ex.o.mana + mps;
}
#else 
    void ht_regen(){
        exec ex = GetLastExec();
        float hps = (ex.o.prop.hp_regen + ex.o.heroprop.hpa_regen) * 0.05;
        float mps = (ex.o.prop.mp_regen + ex.o.heroprop.mpa_regen) * 0.05;
        ex.o.life = ex.o.life + hps;
        ex.o.mana = ex.o.mana + mps;
    }
    
    void ut_regen(){
        exec ex = GetLastExec();
        float hps = ex.o.prop.hp_regen  * 0.05;
        float mps = ex.o.prop.mp_regen  * 0.05;
        ex.o.life = ex.o.life + hps;
        ex.o.mana = ex.o.mana + mps;
    }
#endif

class object {
    unit            subject         = null;

    bool                isAbilityDamage = false;
    bool                isReturnDamage  = false;
    bool                isHero          = false;
    bool                isDummy         = false;
    bool                isBuilding      = false;
    bool                isAncient       = false;
    bool                isMagicImmune   = false;
    bool                isExplosive     = false;

    heroproperties      heroprop        = no_data;
    objectproperties    prop            = no_data;

    int                 processes       = 0;
    int                 pauses          = 0;
    int                 flyUses         = 0;
    int                 inves           = 0;

    bool                isBusy          = false; // For Spells


#if basedata_included
    baseunit basedata       = no_data;
#endif

#if define_goddamn_typeid 
    int     typeId          = 0;
#endif


    destructor(){
        if this.isDummy { RemoveUnit(this.subject)}
        this.deallocate();
    }


#if gamedata_included
    gamedata ownership = no_data;

    gamedata whose(){ return user[GetPlayerId(GetOwningPlayer(this.subject))]}

    void owner(gamedata usr){ SetUnitOwner( this.subject, usr.player, true ) };
    void hirer(gamedata usr){ SetUnitOwner( this.subject, usr.player, false) };
#endif
    static int userdata(){ return GetUnitUserData( GetTriggerUnit() ) - 1 };
    static int userdataof(unit which) { return GetUnitUserData( which ) - 1 };

    float operator f() { return GetUnitFacing( this.subject ) };
    void operator f=(float f){ SetUnitFacing( this.subject, f ) };
    void operator ff=(float f){ SetUnitFacingTimed( this.subject, f, 0.005 ) };

    int userdatais() { return GetUnitUserData( this.subject ) - 1 };
    void setuserdata( int data ) { SetUnitUserData( this.subject, data + 1 ) };
    void setuserdatafor( unit whom, int data ) { SetUnitUserData( whom, data +1 ) }

    void operator x=(float x){ SetUnitX( this.subject, x ) };
    float operator x(){ return GetWidgetX( this.subject ) };
    void operator y=(float y){ SetUnitY( this.subject, y ) };
    float operator y(){ return GetWidgetY( this.subject ) };
    float operator z(){ return GetUnitZ(this.subject ) };

    void operator life=(float lf){ SetWidgetLife( this.subject, flimm(lf,0.405)) };
    float operator life() { return GetWidgetLife( this.subject) };
    float operator maxlife() { return GetUnitState( this.subject, UNIT_STATE_MAX_LIFE )};
    void operator mana=(float m){ SetUnitState( this.subject, UNIT_STATE_MANA, flimm(m,0.0)) };
    float operator mana() { return GetUnitState( this.subject, UNIT_STATE_MANA ) };
    float operator maxmana() { return GetUnitState( this.subject, UNIT_STATE_MAX_MANA )};


    void operator intellect=( int newInt ) { SetHeroInt( this.subject, newInt, true ) };
    int operator intellect(){ return GetHeroInt( this.subject, false ) };
    int operator intellectfull(){ return GetHeroInt( this.subject, true ) };

    void operator agility=( int newAgi ) { SetHeroAgi( this.subject, newAgi, true ) };
    int operator agility(){ return GetHeroAgi( this.subject, false ) };
    int operator agilityfull(){ return GetHeroAgi( this.subject, true ) };

    void operator strength=( int newStr ) { SetHeroStr( this.subject, newStr, true ) };
    int operator strength(){ return GetHeroStr( this.subject, false ) };
    int operator strengthfull(){ return GetHeroStr( this.subject, true ) };

    void revive(float x, float y, bool b) { ReviveHero( this.subject, x, y, b ) };
    void revrct(rect r, bool b) { ReviveHero( this.subject, _rcx(r), _rcy(r), b ) };

#if !define_goddamn_typeid
    int typeId(){ return GetUnitTypeId(this.subject) };
#endif

    void moverect(rect r){ SetUnitPosition( this.subject, _rcx(r), _rcy(r) ) };
    void sel(){ SelectUnitForPlayerSingle( this.subject, ownership.player ) };
    void pan(){ PanCameraToTimedForPlayer( ownership.player, this.x, this.y, 0.0 )};
    void drop( stuff so){ UnitDropItemPoint( this.subject, so.object, this.x, this.y ) };

#if attribute_included
    void operator armorex=(int newint){
        this.prop.xarmor = newint;
        xtSetBonusArmor( this.subject, this.prop.xarmor );
    };

    void operator attackex=(int newint){
        this.prop.xattack = newint;
        xtSetBonusAttack( this.subject, this.prop.xattack );
    };

    void operator strex=(int newint){
        if this.isHero {
            this.heroprop.xstr = newint;
            xtSetBonusStr( this.subject, this.heroprop.xstr );
        };
    };

    void operator agiex=(int newint){
        if this.isHero {
            this.heroprop.xagi = newint;
            xtSetBonusAgi( this.subject, this.heroprop.xagi );
        };
    };

    bool isAlive(){
        return UnitAlive(this.subject);
    }

    bool isHandleAlive(){
        return this.subject != null;
    }

    void operator intex=(int newint){
        if this.isHero {
            this.heroprop.xint = newint;
            xtSetBonusInt( this.subject, this.heroprop.xint );
        };

    };

    

    int operator armorex(){ return this.prop.xarmor};
    int operator attackex(){ return this.prop.xattack};
    int operator strex(){ if this.isHero { return this.heroprop.xstr}; return 0 };
    int operator agiex(){ if this.isHero { return this.heroprop.xagi}; return 0 };
    int operator intex(){ if this.isHero { return this.heroprop.xint}; return 0 };

    int HP( int newValue, bool subOrAdd ){
        int hpstr = 0;
        
        if newValue == 0 {
            return 0;
        }

        if this.isHero {
            hpstr = this.basedata.hero.strength * HP_PER_STRENGTH;
        };

        if subOrAdd {
            if (this.maxlife - newValue) > R2I( (this.basedata.hp + hpstr) * 0.5 ) {
                xtSetBonusHP(this.subject, -newValue );
            } else {
                return 0; // Ошибка, лимит хапания HP достиг своего передела = )
            }
        }
        else{
            xtSetBonusHP(this.subject, newValue );
        }
        return newValue;
    }

    int MP( int newValue, bool subOrAdd ){
        int mpint = 0;
        
        if newValue == 0 {
            return 0;
        }

        if this.isHero {
            mpint = this.basedata.hero.intellect * MP_PER_INTELLECT;
        };
        
        if subOrAdd {
            if (this.maxmana - newValue) > R2I( (this.basedata.mp + mpint) * 0.5 ) {
                xtSetBonusMP(this.subject, -newValue );
            } else {
                return 0; // Ошибка, лимит хапания HP достиг своего передела = )
            }
        }
        else{
            xtSetBonusMP(this.subject, newValue );
        }
        return newValue;
    }

#endif

    define {
        obei_location   = "location"
        obei_origin     = "origin"
        obei_head       = "head"
        obei_chest      = "chest"
        obei_overhead   = "overhead"
        obei_hleft      = "hand left"
        obei_hright     = "hand right"
        obei_fleft      = "foot left"
        obei_fright     = "foot right"
        obei_wleft      = "weapon left"
        obei_wright     = "weapon right"
    };

    void impactEffect(string effFile, string typeImpact){
        if typeImpact == obei_location {
            DestroyEffect(AddSpecialEffect(effFile, GetWidgetX(this.subject), GetWidgetY(this.subject)) )
        } else {
            DestroyEffect(AddSpecialEffectTarget( effFile, this.subject, typeImpact ) )
        }
    }

    // for only dummy objects
    void spell(thistype target, int abilityId, int lvl, int orderId ){
        if this.isDummy {
        UnitAddAbility( this.subject, abilityId );
        if lvl > 1 { SetUnitAbilityLevel( this.subject, abilityId, lvl )};
            IssueTargetOrderById( this.subject, orderId, target.subject );
            UnitApplyTimedLife( this.subject, 0x42544C46, 2.0 );
        } else {
            Debug("|cffFF0303Error|cffFCCC03[|cffbe03fc$object.spell()|cffFCCC03]|cffFF0303:|r Object isn't a Dummy! ")
        }
    }

    int abilityLevel(int abilityId){
        return GetUnitAbilityLevel( this.subject, abilityId );
    }
    float operator flyHeight() {
        return GetUnitFlyHeight( this.subject );
    }
    void operator flyHeight=(float z){
        SetUnitFlyHeight( this.subject, z, 0 );
    }
    void flyHeightEx(float z, float offset ){
        SetUnitFlyHeight( this.subject, z, offset );
    } 

    void anim(string animEffect ){
        SetUnitAnimation( this.subject, animEffect )
    }

    bool nearWith( thistype ot, float dist ){
        return IsUnitInRange( this.subject, ot.subject, dist );
    }

    bool isEnemy(thistype ot){
    #if gamedata_included
        if ( this.isHandleAlive() && ot.isAlive() ) { return IsUnitEnemy( ot.subject, this.ownership.player ) };
    #else
    if ( this.isHandleAlive() && ot.isAlive() ) { return IsUnitEnemy( ot.subject, GetOwningPlayer(this.subject) )};
    #endif

        return false;
    }

    void flymode(bool isOn){
        if isOn {
            if this.flyUses == 0 {
                UnitAddAbility( this.subject, FLY_MODE_ABILITY )
                flyUses++;
            } else { flyUses++; };
        } else {
            if this.flyUses == 1 {
                UnitRemoveAbility( this.subject, FLY_MODE_ABILITY )
                flyUses = 0;
            } else { flyUses--; };
        }
    }

    void busy(){
        this.isBusy = true;
    }

    void freed(){
        this.isBusy = false;
    }

    void pause(){
        if this.pauses == 0 { PauseUnit( this.subject, true ); this.pauses++ } 
            else {this.pauses++;};
    }

    void invulnerable(){
    if this.inves == 0 { SetUnitInvulnerable( this.subject, true ); this.inves++ } 
        else {this.inves++;};
    }

    void vulnerable(){
    if this.inves == 1 { SetUnitInvulnerable( this.subject, false ); this.inves = 0; } 
        else {this.inves--;};
    }

    void continue(){
        if this.pauses == 1 { PauseUnit( this.subject, false ); this.pauses = 0; }
            else{ this.pauses--;};
    }

    void remove(){
        RemoveUnit(this.subject);
    }

    string name(){
        return GetUnitName( this.subject ); 
    }

    void setLevel( int newLevel ){
        if this.isHero {
            SetHeroLevel( this.subject, newLevel, false );
        }
    }

#if timeout_included
    static void waitDestroying(){
        countdown cd = countdown.expired();
        local self = cd.takedata(1);
        if this.processes == 0 && !this.isBusy {
            cd.stop();
            this.destroy()
            cd.destroy()
        }
    }

    void wait_destroy(){
        countdown cd = countdown.create(false);
        cd.putdata(1,this);
        cd.push(.33, __api itself.waitDestroying )
    }

    static void waitRemoving(){
        countdown cd = countdown.expired();
        local self = cd.takedata(1);

        if this.processes == 0 && !this.isBusy {
            cd.stop();
                if !isDummy { 
                    this.remove()
                }
                this.destroy()
            cd.destroy()
        }
    }

    void wait_remove(){
        countdown cd = countdown.create(false);
        cd.putdata(1,this);
        cd.push(.33, __api itself.waitRemoving )
    }
#endif

#if basedata_included
 #if attribute_included
    int getArmor(bool withBonuses){ if this.isHero { return this.basedata.armor + this.prop.xarmor + dex2armor( this.subject, withBonuses )}; return this.basedata.armor + this.prop.xarmor };
    int getAttack(bool withBonuses){ if this.isHero { return this.basedata.attack + this.prop.xattack + mainchar2attack( this.subject, this.basedata.hero.mainchar, withBonuses ) }; return this.basedata.attack + this.prop.xattack };
    int getDS() { if this.basedata.side <= 1 { return this.basedata.dice}; return _RI(this.basedata.dice, this.basedata.side * this.basedata.dice ) };
 #endif
#endif
    
    void kill(){
        KillUnit( this.subject )
    }

    void operator explosive=(bool b){
        this.isExplosive = b;
        SetUnitExploded( this.subject, isExplosive );
    }

    bool operator explosive(){
        return this.isExplosive
    }

    void explode(){
        SetUnitExploded( this.subject, true );
        KillUnit( this.subject );
    }

    __self getKiller(){
        return GetUnitUserData( OBJECT_KILLER ) - 1;
    }

    __self getDying(){
        return GetUnitUserData( OBJECT_DYING ) - 1;
    }

    int handleId(){
        return GetHandleId(this.subject);
    }

    __self getCaster(){
        return GetUnitUserData( OBJECT_CASTER ) - 1
    }

    __self getCastTarget(){
        return GetUnitUserData( OBJECT_CAST_TARGET ) - 1
    }

    bool isValide(){
        return not ( this < 0);
    }

    constructor(unit u){
        new self;
        this.subject = u;

        this.isBuilding = IsUnitType( u, UNIT_TYPE_STRUCTURE );
        this.isAncient = IsUnitType( u, UNIT_TYPE_ANCIENT );
        this.isMagicImmune = IsUnitType( u, UNIT_TYPE_MAGIC_IMMUNE );
        this.isDummy = GetUnitAbilityLevel(u, 'Aloc') > 0; this.isHero  = IsUnitType( u, UNIT_TYPE_HERO );
        this.setuserdata(this);
#if gamedata_included 
        this.ownership = this.whose();
#endif

#if basedata_included
        this.basedata = baseunit.data( GetUnitTypeId(u) );
#endif

#if define_goddamn_typeid 
        this.typeId = GetUnitTypeId( u );
#endif
        if this.isDummy {
            // reserved code;
        }
        else {
            this.prop = new objectproperties;

            if this.isHero {
            this.heroprop = new heroproperties;
            
                exec.create("ht_regen", true ).o = this;

            this.heroprop.hpa_regen = GetHeroStr( u, true ) * str_hps;
            this.heroprop.mpa_regen = GetHeroInt( u, true ) * int_mps;
            } else {
                exec.create("ut_regen", true ).o = this;
            }
            #if sysdamage_included
                if ds_register { TriggerRegisterUnitEvent( DamageSystem_Fixer, u, EVENT_UNIT_DAMAGED ) };
            #endif          
        };

        return this;
    }
}

class stuff {
    item        object          = nil;
#if gamedata_included
    gamedata    ownership       = no_data;
#endif
    bool        isSellable      = false;
    bool        isVulnerable    = true;
    bool        isBuyable       = false;
    bool        hasOwner        = false;

    void userdata(int id){
        SetItemUserData( this.object, id + 1);
    };

#if define_goddamn_typeid 
    int         typeId          = 0;
#endif

#if basedata_included
    baseitem    basedata        = no_data
#endif
    
#if gamedata_included
    gamedata itemowner() { return user[GetPlayerId(GetItemPlayer(this.object))] };
    void toitemowner(gamedata whom){ this.ownership = whom; SetItemPlayer( this.object, whom.player, true ) };
#endif

#if !define_goddamn_typeid 
    int typeId(){ GetItemTypeId( this.object ) };
#endif

    int handleId(){
        return GetHandleId(this.object);
    }

    __self userdataof(item si ){ return GetItemUserData(si) - 1 }

    void remove(){ RemoveItem(this.object) };

    constructor(item thing){
        new self;
        
        this.object     = thing;

        #if define_goddamn_typeid 
            this.typeId = GetItemTypeId( this.object );
        #endif

        #if basedata_included
            this.basedata = baseitem.data(GetItemTypeId(this.object))
        #endif

        #if gamedata_included
            this.ownership  = this.itemowner();
            this.hasOwner   = ownership != user[PLAYER_NEUTRAL_PASSIVE];
        #else
            this.hasOwner   = IsItemOwned( this.object ) && GetItemPlayer(this.object) != Player(PLAYER_NEUTRAL_PASSIVE)
        #endif

        this.isSellable = IsItemPawnable( this.object )
        this.isBuyable  = IsItemSellable( this.object )

         this.userdata(this);

        return this;
    }
}

class objectstack {
    group stack = nil;

    destructor(){
        GroupClear(this.stack);
        DestroyGroup(this.stack);
        this.stack = nil;
    }

    void addObject(object o){
        GroupAddUnit( this.stack, o.subject );
    }

    void removObject(object o){
        GroupRemoveUnit( this.stack, o.subject );
    }

    bool isInStack(object o) {
        return IsUnitInGroup(  o.subject, this.stack  );
    }

    constructor(){
        new self;
            this.stack = CreateGroup();
        return this;
    }
}

#define <new objectstack> = objectstack.create()

object CreateObject(gamedata who, int unitId, float x, float y, float f ){
    return object.create( CreateUnit( who.player, unitId, x, y, f ) )
}

stuff CreateStuff(int itemId, float x, float y ) {
    return stuff.create( CreateItem( itemId, x, y ) )
}

void SetFlyModeAbility(int newFMA, bool isSpellBook){
    FLY_MODE_ABILITY = newFMA;
    if isSpellBook {
        int index = 0x0;
        loop {
            if index:user.flag { 
                SetPlayerAbilityAvailable( index:user.player, newFMA, false );
            };
            index++;
            exif(index > PLAYER_NEUTRAL_PASSIVE);
        }
    }
}

define{
    <new object>( who, id )         = CreateObject( who, id, 0., 0., 0. )
    <new object>( who, id, rct )    = CreateObject( who, id, GetRectCenterX(rct), GetRectCenterY(rct), 270. )
    <new object>( who, id, x, y )   = CreateObject( who, id, x,  y,  0. )
    <new object>( who, id, x, y, f) = CreateObject( who, id, x,  y,  f  )
    <new stuff> ( id )              = CreateStuff( id, 0., 0. )
    <new stuff> ( id, rct )         = CreateStuff( id, GetRectCenterX(rct), GetRectCenterY(rct) )
    <new stuff> ( id, x, y )        = CreateStuff( id, x,  y  ) 
}

object poolObject = no_data;

class breakable {
    int typeId      = 0;
    destructable    object;

    void hide(){
        ShowDestructable( this.object, false);
    }

    void show(){
        ShowDestructable( this.object, true );
    }

    bool isDead(){
        return GetDestructableLife(this.object) <= 0.;
    }

    bool isAlive(){
        return GetDestructableLife(this.object) > 0.;
    }

    void kill(){
        KillDestructable( this.object )
    }

    void operator maxlife=( float newFloat){
        SetDestructableMaxLife( this.object, newFloat )
    }

    float operator maxlife(){
        return GetDestructableMaxLife( this.object )
    }

    void operator life=( float newFloat){
        SetDestructableLife( this.object, newFloat )
    }

    float operator life(){
        return GetDestructableLife( this.object )
    }

    void operator invulnerable=( bool newBool){
        SetDestructableInvulnerable( this.object, newBool )
    }

    bool operator invulnerable(){
        return IsDestructableInvulnerable( this.object )
    }
    
    void animation( string animationName ){
        SetDestructableAnimation( this.object, animationName)
    }

    __self get(){
        return LoadInteger( enity_hash, GetHandleId( GetTriggerDestructable() ), 0 ) - 1
    }

    __self of(destructable d){
        return LoadInteger( enity_hash, GetHandleId( d ), 0 ) - 1
    }
    
    float getX(){
        return GetDestructableX( this.object );
    }

    float getY(){
        return GetDestructableY( this.object );
    }

    constructor( destructable d) {
        new self;
        this.typeId = GetDestructableTypeId( d );
        this.object = d;

        SaveInteger( enity_hash, GetHandleId(d), 0x0, this + 1)
        return this;
    }
}

endnamespace