#guard lotbox_j

#define lotbox_included = true



setdef uses_Lotbox = ,Lotbox 

enum (ssregix) { ssr_all, ssr_cast, ssr_learn };

namespace Lotbox using General

    class lotbox {

        int     box     [16]
        float   chance  [16]
        int     items   = 0

        destructor(){
            int index = 0;
            loop{
                this.box    [index] = 0;
                this.chance [index] = 0;

                index++;
                exif( index == 16)
            }
            free self;
        }
        
        bool lot( int index){
            return GetRandomReal( 0., 100. ) <=this.chance[index]
        }

        int random(){
            if this.items < 1 { return 0};
            return GetRandomInt( 0, this.items - 1 );
        }

        int add_ex( integer typeId, float chance ){
            if this.items < 16 {
                if typeId > 0x3030302F && typeId < 0x7A7A7A7B {
                    this.box    [ this.items ] = typeId
                    this.chance [ this.items ] = chance
                    this.items++;
                    return this.items - 1;
                } else { return 0};
            }
            return 0;
        }

        int add( integer typeId ){
            if this.items < 16 {
                if typeId > 0x3030302F && typeId < 0x7A7A7A7B {
                    this.box [ this.items ] = typeId
                    this.items++;
                    return this.items - 1;
                } else { return 0};
            }
            return 0;
        }

        constructor() {
            new self;
            int index = 0;
            loop{
                this.box[index] = 0;
                index++;
                exif( index == 16)
            }

            return this;
        }
    }

endnamespace