#guard castsystem


namespace CastSystem using General uses_Vectors uses_TimeOut uses_Enities uses_TTager
	
	#define <new syscast> = syscast.create()

	class syscast {

		point  		tp 		= no_data; // Точка-цель 	| Target Point
		object 		to 		= no_data; // Цель 			| Target Object 
		object		io 		= no_data; // Зачинщик		| Initiator Object 
		object  	yo 		= no_data; // Балваничк для снарядов, доп. декора и прочего | Dummy

		int 		data 	= 0; 		// Специальная переменная 

		float 		dmgval  = 0.0;
		float 		healval	= 0.0;
		float		manaval = 0.0;
		float 		dps 	= 0.0;
		float 		hps 	= 0.0;
		float 		mps 	= 0.0;
		float 		dist 	= 0.0;

		point 		loc 	= no_data;

		bool 		processed	= false;

		countdown	cd = no_data; 		// Обратный осчёт

		objectstack stack = no_data;

		destructor(){
			if !(this.cd < null_ptr) {
				if this.cd.autoLiquidation { this.cd.destroy() };
			};

			if !(this.tp < null_ptr) {
				this.tp.destroy();
			};

			if !(this.loc < null_ptr) {
				this.loc.destroy();
			};

			if this.processed {
				if !(this.to < null_ptr) { this.to.processes-- };

				if !(this.io < null_ptr) { this.io.processes-- };
				
				
				if !( this.yo < null_ptr) {
					this.yo.processes--;
					this.yo.wait_remove();
				}
			};

			this.cd = null_ptr;
			this.to = null_ptr;
			this.io = null_ptr;
			this.yo = null_ptr;



			free self;
		}


		void add_processes(){
			if !(this.to < null_ptr) { this.to.processes++ };
			if !(this.io < null_ptr) { this.io.processes++ };
			if !(this.yo < null_ptr) { this.yo.processes++ };
				this.processed = true;
		}


		constructor(){
			return itself.allocate()
		}
	}

endnamespace