#guard gamedata

#define gamedata_included  = true
setdef uses_GameData = ,GameData


    define {
            EVENT_ARMY_ATTACKED         = EVENT_PLAYER_UNIT_ATTACKED
            EVENT_ARMY_CAST             = EVENT_PLAYER_UNIT_SPELL_EFFECT
            EVENT_ARMY_PICKUP_STUFF     = EVENT_PLAYER_UNIT_PICKUP_ITEM
            EVENT_ARMY_DROP_STUFF       = EVENT_PLAYER_UNIT_DROP_ITEM
            EVENT_ARMY_DEATH            = EVENT_PLAYER_UNIT_DEATH

            EVENT_LEADER_QUIT           = EVENT_PLAYER_LEAVE
            EVENT_LEADER_CHAT           = EVENT_PLAYER_CHAT
            EVENT_LEADER_ESC            = EVENT_PLAYER_END_CINEMATIC


            LEADER_KEY_ARROW_LEFT_DOWN      = EVENT_PLAYER_ARROW_LEFT_DOWN 
            LEADER_KEY_ARROW_LEFT_UP        = EVENT_PLAYER_ARROW_LEFT_UP
            LEADER_KEY_ARROW_RIGHT_DOWN     = EVENT_PLAYER_ARROW_RIGHT_DOWN 
            LEADER_KEY_ARROW_RIGHT_UP       = EVENT_PLAYER_ARROW_RIGHT_UP
            LEADER_KEY_ARROW_UP_DOWN        = EVENT_PLAYER_ARROW_UP_DOWN 
            LEADER_KEY_ARROW_UP_UP          = EVENT_PLAYER_ARROW_UP_UP 
            LEADER_KEY_ARROW_DOWN_DOWN      = EVENT_PLAYER_ARROW_DOWN_DOWN
            LEADER_KEY_ARROW_DOWN_UP        = EVENT_PLAYER_ARROW_DOWN_UP
            };


namespace GameData using General
    private int     account = 0 
    private bool    isIncludeComputers = const_computer_on_include

    gamedata user[] 

    class gamedata {
        bool    flag    = false;
        #if const_computer_on_include == true
        bool    comp    = false;
        #endif
        player  player  = null;
        bool    neutral = false;
#if enity_included
        object  hero    = no_data;
#endif
        string  name    = null;
        int     id      = 0;

        destructor(){
            this.player = null;
#if enity_included
            if this.hero != no_data {
            this.hero.destroy();
            }
#endif
            this.name = null;
            free self
        };

        string nameis(){ return this.name };
        playercolor color(){ return GetPlayerColor(this.player) };

        void toname(string newName ){ SetPlayerName( this.player, newName ); this.name = newName };
        void tocolor(playercolor newcolor){ SetPlayerColor( this.player, newcolor); ColorUnits( this.player, newcolor ) };

        void send(string msg){ DisplayTextToPlayer( this.player, 0., 0., msg) };
        void sendt(string msg, float time){ DisplayTimedTextToPlayer( this.player, 0., 0., time, msg ) };

        void foodpoint(int maxFoodpoins) { SetPlayerState( this.player, PLAYER_STATE_RESOURCE_FOOD_CAP, maxFoodpoins ) };
        void foodused( int usedFoodpoints ) {SetPlayerState( this.player, PLAYER_STATE_RESOURCE_FOOD_USED, usedFoodpoints )};
        void foodlimit( int limFoodpoints ) {SetPlayerState( this.player, PLAYER_STATE_FOOD_CAP_CEILING, limFoodpoints )};
        
       bool isValide(){
            return !(this < null_ptr);
        }
        constructor(int id){
            new self;
            this.player = Player(id);
            this.id = id;
            #if const_computer_on_include == true;
             this.comp = GetPlayerController( this.player ) == MAP_CONTROL_COMPUTER;
             this.flag =  ( GetPlayerController( this.player ) == MAP_CONTROL_USER || this.comp ) && GetPlayerSlotState( this.player)  == PLAYER_SLOT_STATE_PLAYING;
            #else
             this.flag = GetPlayerController( this.player ) == MAP_CONTROL_USER && GetPlayerSlotState( this.player)  == PLAYER_SLOT_STATE_PLAYING;
            #endif

            if this.flag {
                this.name = GetPlayerName(this.player); this.id   = GetPlayerId(this.player); account++;
            } else { this.neutral = GetPlayerController(this.player) == MAP_CONTROL_NEUTRAL || GetPlayerController(this.player) == MAP_CONTROL_CREEP };

            this.id:user = this;
            return this
        };
    }
endnamespace